﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NETComp_Csharp_Sample
{
    //The following is a sample showing how to interact with an XK-24 device using the X-keys XK-24 .NET component.

    public partial class Form1 : Form
    {
        //Variables to track the device lights, initial states here based on device defaults
       
        long saveabsolutetime = -1;  //for timestamp demo

        //for large key demo
        int lastKey1=0;
        int lastKey3=0;
        int lastKey5=0;
        byte Key1=0; //4 buttons; bit0=Button 1, bit2=Button 2, bit3=Button 7, bit4=Button 8
        byte Key3=0;
        byte Key5=0;
        long saveabsolutetime2 = -1;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //When valid XK-24 devices are connected they are added to the ConnectedDevices list
            //If this list is empty, then no valid devices are connected currently
            if (xk24_1.ConnectedDevices == null)
            {
                deviceStatus.Text = "No XK-24 Connected";
                deviceStatus.ForeColor = Color.Red;
            }
            else
            {
                deviceStatus.Text = "XK-24 Connected";
                deviceStatus.ForeColor = Color.Green;

                //Gets the Unit ID from the device
                lblUID.Text = "Unit ID: " + xk24_1.ConnectedDevices[0].UnitID;

                //Gets the OEM Version ID from the device
                lblOEM.Text = "OEM ID: " + xk24_1.ConnectedDevices[0].OEMVersion;

                //Gets the Product ID from the device
                lblProductID.Text = "Product ID: " + xk24_1.ConnectedDevices[0].Pid;
            }
        }

        private void HandleButtons(Xk24.XKeyEventArgs e)
        {
            //Handle state changes of the buttons
            bool recordtimestamp = false; //set to true on the desired presses and releases, for large key demo
            if (e.PressState == true) //button press
            {
                switch (e.CID)
                {
                    case 1001:
                        lblButton01.Text = "01-dn";
                        //Large key demo - set this button's 1st bit in Key1
                        Key1=(byte)(Key1 | 1);
                        break;
                    case 1002:
                        lblButton02.Text = "02-dn";
                        //Large key demo - set this button's 2nd bit in Key1
                        Key1=(byte)(Key1 | 2);
                        break;
                    case 1003:
                        lblButton03.Text = "03-dn";
                        //Large key demo - set this button's 1st bit in Key3
                        Key3 = (byte)(Key3 | 1);
                        break;
                    case 1004:
                        lblButton04.Text = "04-dn";
                        //Large key demo - set this button's 2nd bit in Key3
                        Key3 = (byte)(Key3 | 2);
                        break;
                    case 1005:
                        lblButton05.Text = "05-dn";
                        //Large key demo - set this button's 1st bit in Key5
                        Key5 = (byte)(Key3 | 1);
                        break;
                    case 1006:
                        lblButton06.Text = "06-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey6.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1007:
                        lblButton07.Text = "07-dn";
                        //Large key demo - set this button's 3rd bit in Key1
                        Key1 = (byte)(Key1 | 4);
                        break;
                    case 1008:
                        lblButton08.Text = "08-dn";
                        //Large key demo - set this button's 4th bit in Key1
                        Key1 = (byte)(Key1 | 8);
                        break;
                    case 1009:
                        lblButton09.Text = "09-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey9.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1010:
                        lblButton10.Text = "10-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey10.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1011:
                        lblButton11.Text = "11-dn";
                        //Large key demo - set this button's 2nd bit in Key5
                        Key5 = (byte)(Key5 | 2);
                        break;
                    case 1012:
                        lblButton12.Text = "12-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey12.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1013:
                        lblButton13.Text = "13-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey13.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1014:
                        lblButton14.Text = "14-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey14.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1015:
                        lblButton15.Text = "15-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey15.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1016:
                        lblButton16.Text = "16-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey16.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1017:
                        lblButton17.Text = "17-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey17.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1018:
                        lblButton18.Text = "18-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey18.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1019:
                        lblButton19.Text = "19-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey19.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1020:
                        lblButton20.Text = "20-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey20.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1021:
                        lblButton21.Text = "21-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey21.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1022:
                        lblButton22.Text = "22-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey22.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1023:
                        lblButton23.Text = "23-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey23.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1024:
                        lblButton24.Text = "24-dn";
                        System.Media.SystemSounds.Beep.Play();
                        BtnKey24.BackColor = Color.Lime;
                        recordtimestamp = true;
                        break;
                    case 1025:
                        lblProgSwitch.Text = "Prog. Switch-dn";
                        recordtimestamp = true;
                        break;
                }
            }
            else //button release
            {
                byte bitindex;
                switch (e.CID)
                {
                    case 1001:
                        lblButton01.Text = "01-up";
                        //Large key demo - clear this button's 1st bit in Key1
                        bitindex = 0;
                        Key1 &= (byte)(~(1 << bitindex));
                        break;
                    case 1002:
                        lblButton02.Text = "02-up";
                        //Large key demo - clear this button's 2nd bit in Key1
                        bitindex = 1;
                        Key1 &= (byte)(~(1 << bitindex));
                        break;
                    case 1003:
                        lblButton03.Text = "03-up";
                        //Large key demo - clear this button's 1st bit in Key3
                        bitindex = 0;
                        Key3 &= (byte)(~(1 << bitindex));
                        break;
                    case 1004:
                        lblButton04.Text = "04-up";
                        //Large key demo - clear this button's 2nd bit in Key3
                        bitindex = 1;
                        Key3 &= (byte)(~(1 << bitindex));
                        break;
                    case 1005:
                        lblButton05.Text = "05-up";
                        //Large key demo - clear this button's 1st bit in Key1
                        bitindex = 0;
                        Key5 &= (byte)(~(1 << bitindex));
                        break;
                    case 1006:
                        lblButton06.Text = "06-up";
                        BtnKey6.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1007:
                        lblButton07.Text = "07-up";
                        //Large key demo - clear this button's 3rd bit in Key1
                        bitindex = 2;
                        Key1 &= (byte)(~(1 << bitindex));
                        break;
                    case 1008:
                        lblButton08.Text = "08-up";
                        //Large key demo - clear this button's 4th bit in Key1
                        bitindex = 3;
                        Key1 &= (byte)(~(1 << bitindex));
                        break;
                    case 1009:
                        lblButton09.Text = "09-up";
                        BtnKey9.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1010:
                        lblButton10.Text = "10-up";
                        BtnKey10.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1011:
                        lblButton11.Text = "11-up";
                        //Large key demo - clear this button's 2nd bit in Key1
                        bitindex = 1;
                        Key5 &= (byte)(~(1 << bitindex));
                        break;
                    case 1012:
                        lblButton12.Text = "12-up";
                        BtnKey12.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1013:
                        lblButton13.Text = "13-up";
                        BtnKey13.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1014:
                        lblButton14.Text = "14-up";
                        BtnKey14.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1015:
                        lblButton15.Text = "15-up";
                        BtnKey15.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1016:
                        lblButton16.Text = "16-up";
                        BtnKey16.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1017:
                        lblButton17.Text = "17-up";
                        BtnKey17.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1018:
                        lblButton18.Text = "18-up";
                        BtnKey18.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1019:
                        lblButton19.Text = "19-up";
                        BtnKey19.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1020:
                        lblButton20.Text = "20-up";
                        BtnKey20.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1021:
                        lblButton21.Text = "21-up";
                        BtnKey21.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1022:
                        lblButton22.Text = "22-up";
                        BtnKey22.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1023:
                        lblButton23.Text = "23-up";
                        BtnKey23.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1024:
                        lblButton24.Text = "24-up";
                        BtnKey24.BackColor = SystemColors.Control;
                        recordtimestamp = true;
                        break;
                    case 1025:
                        lblProgSwitch.Text = "Prog. Switch-up";
                        recordtimestamp = true;
                        break;
                }
            }
            lblUID.Text = "Unit ID: " + xk24_1.ConnectedDevices[0].UnitID.ToString();
            //Time Stamp Info
            long absolutetime = e.TimeStamp; //gives time in ms since boot of X-keys unit
            long absolutetimesec = absolutetime / 1000; //convert to seconds
            lblATime.Text = "Absolute Time: " + absolutetimesec.ToString() + " s";
            if (saveabsolutetime != -1)
            {
                lblDTime.Text = "Delta Time: " + (absolutetime - saveabsolutetime).ToString() + " ms"; //this gives the time between button presses or between any generated data reports
            }
            saveabsolutetime = absolutetime;

            //Large key demo
            //Key 1
            if (Key1!=0 && lastKey1==0) //press
            {
                System.Media.SystemSounds.Beep.Play();
                BtnKey1.BackColor = Color.Lime;
                recordtimestamp = true;
            }
            else if (lastKey1 != 0 && Key1 == 0) //release
            {
                BtnKey1.BackColor = SystemColors.Control;
                recordtimestamp = true;
            }
            lastKey1 = Key1;
            //Key 3
            if (Key3 != 0 && lastKey3 == 0) //press
            {
                System.Media.SystemSounds.Beep.Play();
                BtnKey3.BackColor = Color.Lime;
                recordtimestamp = true;
            }
            else if (lastKey3 != 0 && Key3 == 0) //release
            {
                BtnKey3.BackColor = SystemColors.Control;
                recordtimestamp = true;
            }
            lastKey3 = Key3;
            //Key 1
            if (Key5 != 0 && lastKey5 == 0) //press
            {
                System.Media.SystemSounds.Beep.Play();
                BtnKey5.BackColor = Color.Lime;
                recordtimestamp = true;
            }
            else if (lastKey5 != 0 && Key5 == 0) //release
            {
                BtnKey5.BackColor = SystemColors.Control;
                recordtimestamp = true;
            }
            lastKey5 = Key5;
            //large key time stamp
            if (recordtimestamp == true)
            {
                long absolutetime2 = e.TimeStamp; //gives time in ms since boot of X-keys unit
                long absolutetimesec2 = absolutetime / 1000; //convert to seconds
                lblATime2.Text = "Absolute Time: " + absolutetimesec2.ToString() + " s";
                if (saveabsolutetime2 != -1)
                {
                    lblDTime2.Text = "Delta Time: " + (absolutetime2 - saveabsolutetime2).ToString() + " ms"; //this gives the time between button presses or between any generated data reports
                }
                saveabsolutetime2 = absolutetime2;
                recordtimestamp = false;
            }

        }

        private void btnGreenLED_Click(object sender, EventArgs e)
        {
            
        }

        private void btnRedLED_Click(object sender, EventArgs e)
        {
            
        }

        private void btnGreenLEDFlash_Click(object sender, EventArgs e)
        {
           
        }

        private void btnRedLEDFlash_Click(object sender, EventArgs e)
        {
            
        }

        private void btnSaveState_Click(object sender, EventArgs e)
        {
            //Saves backlighting state to the memory of the device, when called the current state of the backlights will be the default state when device is booted
            xk24_1.SaveBacklightState(0);
        }

        private void btnUID_Click(object sender, EventArgs e)
        {
            int id = Convert.ToInt32(txtUID.Text);

            //Sets device Unit ID
            xk24_1.SetDeviceUID(0, id);
            lblUID.Text = "Unit ID: " + xk24_1.ConnectedDevices[0].UnitID.ToString();
        }

        private void btnOEM_Click(object sender, EventArgs e)
        {
            int id = Convert.ToInt32(txtOEM.Text);

            //Sets device OEM Version ID
            xk24_1.SetOEMVersionID(0, id, true);
            //after sending this command the device will disconnect and reconnect
        }

        private void xk24_1_DevicePlug(Xk24.XKeyPlugEventArgs e)
        {
            deviceStatus.Text = "XK-24 Plugged, Unit ID: " + e.UID.ToString() + ", OEM ID: " + e.OEMVersionID.ToString() + ", Product ID: " + e.PID.ToString();
            deviceStatus.ForeColor = Color.Green;

            lblUID.Text = "Unit ID: " + e.UID.ToString();
            lblOEM.Text = "OEM ID: " + e.OEMVersionID.ToString();
            lblProductID.Text = "Product ID: " + e.PID.ToString();
        }
        
        private void xk24_1_DeviceUnplug(Xk24.XKeyPlugEventArgs e)
        {
            deviceStatus.Text = "XK-24 Unplugged, Unit ID: " + e.UID.ToString() + ", OEM ID: " + e.OEMVersionID.ToString() + ", Product ID: " + e.PID.ToString();
            deviceStatus.ForeColor = Color.Red;

            lblUID.Text = "Unit ID: ";
            lblOEM.Text = "OEM ID: ";
            lblProductID.Text = "Product ID: ";
        }

        private void xk24_1_ButtonChange(Xk24.XKeyEventArgs e)
        {
            //This method handles the button change event for the device
            HandleButtons(e);
        }

        private void xk24_1_GenerateReportData(Xk24.XKeyEventArgs e)
        {
            HandleButtons(e);
        }

        private void chkGreen_CheckedChanged(object sender, EventArgs e)
        {
            if (chkGreen.Checked == false)
            {
                xk24_1.SetGreenIndicator(0, 0);
            }
            else
            {
                if (chkGreenFlash.Checked == true)
                {
                    xk24_1.SetGreenIndicator(0, 2);
                }
                else
                {
                    xk24_1.SetGreenIndicator(0, 1);
                }
            }
        }

        private void chkRed_CheckedChanged(object sender, EventArgs e)
        {
            if (chkRed.Checked == false)
            {
                xk24_1.SetRedIndicator(0, 0);
            }
            else
            {
                if (chkRedFlash.Checked == true)
                {
                    xk24_1.SetRedIndicator(0, 2);
                }
                else
                {
                    xk24_1.SetRedIndicator(0, 1);
                }
            }
        }

        private void chkGreenFlash_CheckedChanged(object sender, EventArgs e)
        {
            if (chkGreen.Checked == true)
            {
                if (chkGreenFlash.Checked == true)
                {
                    xk24_1.SetGreenIndicator(0, 2);
                }
                else
                {
                    xk24_1.SetGreenIndicator(0, 1);
                }
            }
        }

        private void chkRedFlash_CheckedChanged(object sender, EventArgs e)
        {
            if (chkRed.Checked == true)
            {
                if (chkRedFlash.Checked == true)
                {
                    xk24_1.SetRedIndicator(0, 2);
                }
                else
                {
                    xk24_1.SetRedIndicator(0, 1);
                }
            }
        }

      

        


    }
}
